################################################################################################
#
# Cyclops Boss
#
################################################################################################

scoreboard objectives add rc minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add ET dummy
scoreboard objectives add facing_direction dummy
scoreboard objectives add mult dummy
scoreboard objectives add sneak minecraft.custom:minecraft.sneak_time
scoreboard objectives add leg_swing dummy
scoreboard objectives add leg_swing_timer dummy
scoreboard objectives add arm_swing dummy
scoreboard objectives add arm_swing_timer dummy
scoreboard objectives add is_moving dummy
scoreboard objectives add motion_toggle dummy
scoreboard objectives add blink dummy
scoreboard objectives add pound dummy
scoreboard objectives add body_y dummy
scoreboard objectives add c_jump dummy
scoreboard objectives add laser dummy
scoreboard objectives add laser_lt dummy
scoreboard objectives add motion dummy
scoreboard objectives add stones dummy
scoreboard objectives add arm_z dummy
scoreboard objectives add wave_lt dummy
scoreboard objectives add slam_cd dummy
scoreboard objectives add grunt dummy
scoreboard objectives add attack_timer dummy
scoreboard objectives add boss_health dummy
scoreboard objectives add r dummy
scoreboard objectives add laser_charge dummy


gamerule logAdminCommands false
gamerule sendCommandFeedback false
gamerule commandBlockOutput false
function cyclops:entitytype




################################################### General #####################################################




execute at @e[tag=center] run tp @e[tag=body] ^ ^4.4 ^
execute at @e[tag=center] run tp @e[tag=leg_left] ^1.15 ^4.2 ^
execute at @e[tag=center] run tp @e[tag=leg_right] ^-1.15 ^4.2 ^
execute at @e[tag=body] run tp @e[tag=arm_left] ^2.9 ^6.3 ^
execute at @e[tag=body] run tp @e[tag=arm_right] ^-2.9 ^6.3 ^
execute at @e[tag=body] run tp @e[tag=head] ^ ^7.0 ^
execute at @e[tag=center] run tp @e[tag=dd] ^ ^13 ^1

effect give @e[tag=dd] regeneration 9 240 true
effect give @e[tag=dd] resistance 9 240 true
effect give @e[tag=c_h] invisibility 99 9 true
execute as @e[tag=ai] at @s run tp @e[tag=center,limit=1,sort=nearest] @s
execute as @e[tag=center] at @s run tp @e[tag=center,limit=1,sort=nearest] ~ ~ ~ ~ 0
execute as @e[tag=rot_part] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=center,limit=1] Rotation[0] 1


################################################### Spawn #####################################################

execute at @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] run execute at @e[type=item,nbt={Item:{id:"minecraft:rotten_flesh",Count:64b},OnGround:1b},distance=..1] run execute at @e[type=item,nbt={Item:{id:"minecraft:ender_eye",Count:1b},OnGround:1b},distance=..1] if block ~ ~-1 ~ diamond_block if block ~1 ~-1 ~ obsidian if block ~-1 ~-1 ~ obsidian if block ~ ~-1 ~1 obsidian if block ~ ~-1 ~-1 obsidian if block ~1 ~ ~ fire if block ~-1 ~ ~ fire if block ~ ~ ~1 fire if block ~ ~ ~-1 fire run summon area_effect_cloud ~ ~ ~ {Duration:0,Tags:[c_spawner]}
execute at @e[tag=c_spawner] run kill @e[type=item,distance=..2]
execute at @e[tag=c_spawner] run fill ~-1 ~ ~ ~1 ~-1 ~ air 
execute at @e[tag=c_spawner] run fill ~ ~ ~-1 ~ ~-1 ~1 air 
execute at @e[tag=c_spawner] run function cyclops:spawn



################################################### Laser Weapon #####################################################




scoreboard players add @a laser_charge 0
scoreboard players set @a[scores={rc=1..}] laser_charge 7
scoreboard players remove @a[scores={laser_charge=1..}] laser_charge 1
execute as @a[scores={laser_charge=1..}] at @s run function cyclops:laser_ability


effect give @a[scores={laser_charge=2..}] slowness 1 2 true
effect clear @a[scores={laser_charge=1}] slowness
execute at @a[scores={laser_charge=1}] run playsound laser2 master @a ~ ~ ~ 1.0 1

scoreboard players set @a rc 0






##################################################################### Attacks ###############################################

scoreboard players add @e[tag=center] attack_timer 0
execute at @p run scoreboard players remove @e[tag=center,scores={attack_timer=1..},distance=..60] attack_timer 1
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @a[distance=..9] run execute at @s run summon area_effect_cloud ~ ~ ~ {Tags:["r","r1"],Duration:0} 
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @a[distance=8..55] run execute at @s run summon area_effect_cloud ~ ~ ~ {Tags:["r","r2"],Duration:0} 
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @a[distance=8..45] run execute at @s run summon area_effect_cloud ~ ~ ~ {Tags:["r","r3"],Duration:0} 
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @a[distance=15..40] run execute at @s run summon area_effect_cloud ~ ~ ~ {Tags:["r","r4"],Duration:0} 
execute as @e[tag=center,scores={attack_timer=..0}] at @s run scoreboard players set @e[tag=r,sort=random,limit=1] r 1
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @e[tag=r1,scores={r=1}] run scoreboard players set @e[tag=center,sort=nearest,limit=1] c_jump 1
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @e[tag=r2,scores={r=1}] run scoreboard players set @e[tag=center,sort=nearest,limit=1] pound 1
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @e[tag=r3,scores={r=1}] run scoreboard players set @e[tag=center,sort=nearest,limit=1] laser 1
execute as @e[tag=center,scores={attack_timer=..0}] at @s run execute at @e[tag=r4,scores={r=1}] run scoreboard players set @e[tag=center,sort=nearest,limit=1] stones 1

scoreboard players set @e[tag=center,scores={attack_timer=..0}] attack_timer 100


scoreboard players set @e[tag=center,scores={c_jump=1..}] attack_timer 80
scoreboard players set @e[tag=center,scores={pound=1..}] attack_timer 100
scoreboard players set @e[tag=center,scores={laser=1..}] attack_timer 100
scoreboard players set @e[tag=center,scores={stones=1..}] attack_timer 120


##################################################################### Damage ###############################################

execute at @e[tag=dd,nbt={HurtTime:10s}] run execute at @e[tag=body] positioned ^ ^10 ^1.2 run particle block red_concrete_powder ~ ~ ~ 0.1 0.1 0.1 0.1 20
execute at @e[tag=dd,nbt={HurtTime:10s}] run scoreboard players set @e[tag=center,scores={blink=0},sort=nearest,limit=1] blink 1
execute at @e[tag=dd,nbt={HurtTime:10s}] run scoreboard players remove @e[tag=center,sort=nearest,limit=1] boss_health 1
execute at @e[tag=dd,nbt={HurtTime:10s}] run execute as @e[tag=center,limit=1,sort=nearest,scores={grunt=0}] at @s run playsound grunt1 master @a ~ ~ ~ 1.7 0.7
execute at @e[tag=dd,nbt={HurtTime:10s}] run execute as @e[tag=center,limit=1,sort=nearest,scores={grunt=1}] at @s run playsound grunt2 master @a ~ ~ ~ 1.7 0.66
execute at @e[tag=dd,nbt={HurtTime:10s}] run execute as @e[tag=center,limit=1,sort=nearest,scores={grunt=2}] at @s run playsound grunt3 master @a ~ ~ ~ 1.7 0.7
execute at @e[tag=dd,nbt={HurtTime:10s}] run execute as @e[tag=center,limit=1,sort=nearest,scores={grunt=3}] at @s run playsound grunt4 master @a ~ ~ ~ 1.7 0.62
execute at @e[tag=dd,nbt={HurtTime:10s}] run execute as @e[tag=center,limit=1,sort=nearest,scores={grunt=4}] at @s run playsound grunt5 master @a ~ ~ ~ 1.7 0.7
execute at @e[tag=dd,nbt={HurtTime:10s}] run scoreboard players add @e[tag=center,limit=1,sort=nearest] grunt 1
execute at @e[tag=dd,nbt={HurtTime:10s}] run scoreboard players set @e[tag=center,limit=1,sort=nearest,scores={grunt=5..}] grunt 0

scoreboard players add @e[tag=center] grunt 0
scoreboard players add @e[tag=center] boss_health 0
execute store result bossbar minecraft:1 value run scoreboard players get @e[tag=center,limit=1] boss_health

bossbar set minecraft:1 visible false
execute at @e[tag=center] run bossbar set minecraft:1 visible true

bossbar create 1 "Cyclops Health"
bossbar set minecraft:1 max 50
bossbar set minecraft:1 color blue
bossbar set minecraft:1 style progress
bossbar set minecraft:1 players @a

execute as @e[tag=center,scores={boss_health=..0}] at @s run playsound minecraft:entity.enderdragon.death master @a ~ ~ ~ 2.0 0.8
execute as @e[tag=center,scores={boss_health=..0}] at @s run particle large_smoke ~ ~4 ~ 2 8 2 0.1 10 force
execute as @e[tag=center,scores={boss_health=..0}] at @s run particle explosion ~ ~5 ~ 2 10 2 0.1 50 force
execute as @e[tag=center,scores={boss_health=..0}] at @s run execute as @e[tag=c_h] run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon item ~ ~ ~ {Item:{id:"minecraft:carrot_on_a_stick",Count:1,tag:{Damage:0s,Unbreakable:1,display:{Name:"{\"text\":\"§2Cyclops Eye\"}"},HideFlags:63}}}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~ ~7 ~ {Value:7000}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~1 ~6 ~ {Value:5000}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~2 ~9 ~1 {Value:3000}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~ ~3 ~-1 {Value:2000}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~-1 ~1 ~-2 {Value:500}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~2 ~4 ~2 {Value:100}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~-2 ~4 ~-3 {Value:10}
execute as @e[tag=center,scores={boss_health=..0}] at @s run summon minecraft:xp_orb ~4 ~4 ~2 {Value:10}
execute as @e[tag=center,scores={boss_health=..0}] at @s run kill @e[tag=b_part]
data merge entity @e[tag=ai,limit=1] {Anger:10000}




##################################################################### Movement Transition ###############################################

scoreboard players add @e[tag=center] motion 0
execute as @e[tag=ai,nbt={Motion:[0.0,0.0,0.0]}] at @s run scoreboard players remove @e[tag=center,limit=1,sort=nearest,scores={motion=-9..}] motion 2
scoreboard players add @e[tag=center,limit=1,sort=nearest,scores={motion=..9}] motion 1

scoreboard players add @e[tag=center] is_moving 0
scoreboard players set @e[tag=center,scores={motion=..-1}] is_moving 0
scoreboard players set @e[tag=center,scores={motion=1..}] is_moving 1


execute as @e[tag=center,scores={is_moving=0}] run scoreboard players set @e[tag=b_part] is_moving 0
execute as @e[tag=center,scores={is_moving=1}] run scoreboard players set @e[tag=b_part] is_moving 1
execute as @e[tag=center,scores={pound=1..}] run scoreboard players set @e[tag=b_part] is_moving 0
execute as @e[tag=center,scores={c_jump=1..}] run scoreboard players set @e[tag=b_part] is_moving 0
execute as @e[tag=center,scores={laser=1..}] run scoreboard players set @e[tag=b_part] is_moving 0


scoreboard players set @e[tag=center,scores={is_moving=0,motion_toggle=..0}] motion_toggle 0
scoreboard players set @e[tag=center,scores={is_moving=1,motion_toggle=0..}] motion_toggle 0

scoreboard players add @e[tag=center,scores={is_moving=0}] motion_toggle 1
scoreboard players remove @e[tag=center,scores={is_moving=1}] motion_toggle 1
scoreboard players operation @e[tag=b_part] motion_toggle = @e[tag=center] motion_toggle






#################################################################### Leg Swing ############################################################

scoreboard players add @e[tag=leg] leg_swing 0
scoreboard players add @e[tag=leg] right_swing 0

scoreboard players set @e[tag=leg_left,scores={motion_toggle=-2}] leg_swing_timer 1
scoreboard players set @e[tag=leg_right,scores={motion_toggle=-2}] leg_swing_timer 27


scoreboard players add @e[tag=leg] leg_swing_timer 0
scoreboard players add @e[tag=leg,scores={leg_swing_timer=1..,is_moving=1}] leg_swing_timer 1


scoreboard players remove @e[tag=leg,scores={leg_swing=10..,is_moving=0}] leg_swing 1
scoreboard players add @e[tag=leg,scores={leg_swing=..-10,is_moving=0}] leg_swing 1
scoreboard players remove @e[tag=leg,scores={leg_swing=1..,is_moving=0}] leg_swing 1
scoreboard players add @e[tag=leg,scores={leg_swing=..-1,is_moving=0}] leg_swing 1

scoreboard players set @e[tag=leg,scores={leg_swing_timer=54..}] leg_swing_timer 1

scoreboard players set @e[tag=leg,scores={is_moving=1,leg_swing_timer=1}] leg_swing 0
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=2..5}] leg_swing 3
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=6..10}] leg_swing 2
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=11..15}] leg_swing 1
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=16..20}] leg_swing 1
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=21..25}] leg_swing 2
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=26..33}] leg_swing 3
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=34..38}] leg_swing 2
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=39..43}] leg_swing 1
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=44..48}] leg_swing 2
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=49..53}] leg_swing 3

execute as @e[tag=leg] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s leg_swing





###################################################################### Arm Swing ##########################################################


scoreboard players add @e[tag=arm] arm_swing 0
scoreboard players add @e[tag=arm] right_swing 0

scoreboard players set @e[tag=arm_left,scores={motion_toggle=-2}] arm_swing_timer 27
scoreboard players set @e[tag=arm_right,scores={motion_toggle=-2}] arm_swing_timer 1


scoreboard players add @e[tag=arm] arm_swing_timer 0
scoreboard players add @e[tag=arm,scores={arm_swing_timer=1..,is_moving=1}] arm_swing_timer 1


scoreboard players remove @e[tag=arm,scores={arm_swing=10..,is_moving=0,c_jump=..0}] arm_swing 1
scoreboard players add @e[tag=arm,scores={arm_swing=..-10,is_moving=0,c_jump=..0}] arm_swing 1
scoreboard players remove @e[tag=arm,scores={arm_swing=1..,is_moving=0,c_jump=..0}] arm_swing 1
scoreboard players add @e[tag=arm,scores={arm_swing=..-1,is_moving=0,c_jump=..0}] arm_swing 1

scoreboard players set @e[tag=arm,scores={arm_swing_timer=54..}] arm_swing_timer 1

scoreboard players set @e[tag=arm,scores={is_moving=1,arm_swing_timer=1}] arm_swing 0
scoreboard players add @e[tag=arm,scores={is_moving=1,arm_swing_timer=2..5}] arm_swing 3
scoreboard players add @e[tag=arm,scores={is_moving=1,arm_swing_timer=6..10}] arm_swing 2
scoreboard players add @e[tag=arm,scores={is_moving=1,arm_swing_timer=11..15}] arm_swing 1
scoreboard players remove @e[tag=arm,scores={is_moving=1,arm_swing_timer=16..20}] arm_swing 1
scoreboard players remove @e[tag=arm,scores={is_moving=1,arm_swing_timer=21..25}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={is_moving=1,arm_swing_timer=26..33}] arm_swing 3
scoreboard players remove @e[tag=arm,scores={is_moving=1,arm_swing_timer=34..38}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={is_moving=1,arm_swing_timer=39..43}] arm_swing 1
scoreboard players add @e[tag=arm,scores={is_moving=1,arm_swing_timer=44..48}] arm_swing 2
scoreboard players add @e[tag=arm,scores={is_moving=1,arm_swing_timer=49..53}] arm_swing 3

execute as @e[tag=arm] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s arm_swing




#################################################################### Blink #################################################################


scoreboard players add @e[tag=center] blink 0
scoreboard players add @e[tag=center,scores={blink=1..}] blink 1
scoreboard players set @e[tag=center,scores={blink=20..}] blink 0
scoreboard players operation @e[tag=head] blink = @e[tag=center] blink

data merge entity @e[tag=head,scores={blink=0},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:5}}]}
data merge entity @e[tag=head,scores={blink=1},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:6}}]}
data merge entity @e[tag=head,scores={blink=2},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:7}}]}
data merge entity @e[tag=head,scores={blink=3},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:8}}]}
data merge entity @e[tag=head,scores={blink=4},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:9}}]}
data merge entity @e[tag=head,scores={blink=5},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:10}}]}
data merge entity @e[tag=head,scores={blink=6},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:9}}]}
data merge entity @e[tag=head,scores={blink=7},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:8}}]}
data merge entity @e[tag=head,scores={blink=8},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:7}}]}
data merge entity @e[tag=head,scores={blink=9},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:6}}]}
data merge entity @e[tag=head,scores={blink=10},limit=1] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:5}}]}






############################################################# Ground Pound #################################################################

scoreboard players add @e[tag=center] body_y 0
scoreboard players add @e[tag=center] pound 0
scoreboard players add @e[tag=center,scores={pound=1..}] pound 1
scoreboard players set @e[tag=center,scores={pound=53..}] pound 0

execute as @e[tag=center,scores={pound=2}] at @s run playsound smash master @a ~ ~ ~ 2.0 1

scoreboard players set @e[tag=center,scores={pound=2}] body_y 0
scoreboard players set @e[tag=center,scores={pound=2}] body_y 0
scoreboard players add @e[tag=center,scores={pound=1..20}] body_y 1
scoreboard players add @e[tag=center,scores={pound=3..20}] body_y 1
scoreboard players add @e[tag=center,scores={pound=5..20}] body_y 1
scoreboard players add @e[tag=center,scores={pound=7..20}] body_y 1
scoreboard players add @e[tag=center,scores={pound=9..20}] body_y 2

scoreboard players set @e[tag=center,scores={pound=52}] body_y 0
scoreboard players set @e[tag=center,scores={pound=52}] arm_swing 0


scoreboard players remove @e[tag=center,scores={pound=1..3,arm_swing=-90..}] arm_swing 10
scoreboard players remove @e[tag=center,scores={pound=4..8,arm_swing=-90..}] arm_swing 20
scoreboard players set @e[tag=center,scores={pound=8}] arm_swing -90
scoreboard players add @e[tag=center,scores={pound=9..14,arm_swing=..-40}] arm_swing 4
scoreboard players add @e[tag=center,scores={pound=15..20,arm_swing=..-40}] arm_swing 7
scoreboard players add @e[tag=center,scores={pound=31..40,arm_swing=..0}] arm_swing 2
scoreboard players add @e[tag=center,scores={pound=41..50,arm_swing=..0}] arm_swing 4
scoreboard players remove @e[tag=center,scores={pound=31..34}] body_y 3
scoreboard players remove @e[tag=center,scores={pound=35..45}] body_y 6
scoreboard players remove @e[tag=center,scores={pound=46..48}] body_y 3
scoreboard players remove @e[tag=center,scores={pound=49..51}] body_y 1



scoreboard players operation @e[tag=head] pound = @e[tag=center] pound
scoreboard players operation @e[tag=body] pound = @e[tag=center] pound
scoreboard players operation @e[tag=body] body_y = @e[tag=center] body_y
scoreboard players operation @e[tag=head] body_y = @e[tag=center] body_y
scoreboard players operation @e[tag=arm] arm_swing = @e[tag=center,scores={pound=1..}] arm_swing

execute as @e[tag=body] at @s run execute store result entity @s Rotation[1] float 1 run scoreboard players get @s body_y
execute as @e[tag=body] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s body_y
execute as @e[tag=head] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s body_y

execute as @e[tag=arm] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s arm_swing


execute as @e[tag=center,scores={pound=1..}] at @s run data merge entity @e[tag=ai,limit=1,sort=nearest] {Motion:[0.0,0.0,0.0]}


execute at @e[tag=center] run tp @e[tag=body] ^ ^4.4 ^
execute at @e[tag=center] run tp @e[tag=leg_left] ^1.15 ^4.2 ^
execute at @e[tag=center] run tp @e[tag=leg_right] ^-1.15 ^4.2 ^
execute at @e[tag=body] run tp @e[tag=arm_left] ^2.9 ^6.3 ^
execute at @e[tag=body] run tp @e[tag=arm_right] ^-2.9 ^6.3 ^
execute at @e[tag=body] run tp @e[tag=head] ^ ^7.0 ^
execute at @e[tag=center] run tp @e[tag=dd] ^ ^13 ^1


execute at @e[tag=body,scores={pound=1..7}] run tp @e[tag=head] ^ ^7.0 ^1
execute at @e[tag=body,scores={pound=1..7}] run tp @e[tag=arm_left] ^2.9 ^6.3 ^1
execute at @e[tag=body,scores={pound=1..7}] run tp @e[tag=arm_right] ^-2.9 ^6.3 ^1
execute at @e[tag=body,scores={pound=8..18}] run tp @e[tag=head] ^ ^7.0 ^2
execute at @e[tag=body,scores={pound=8..18}] run tp @e[tag=arm_left] ^2.9 ^6.3 ^2
execute at @e[tag=body,scores={pound=8..18}] run tp @e[tag=arm_right] ^-2.9 ^6.3 ^2
execute at @e[tag=body,scores={pound=31..48}] run tp @e[tag=head] ^ ^7.0 ^-1.5
execute at @e[tag=body,scores={pound=31..48}] run tp @e[tag=arm_left] ^2.9 ^6.3 ^-1.5
execute at @e[tag=body,scores={pound=31..48}] run tp @e[tag=arm_right] ^-2.9 ^6.3 ^-1.5

execute at @e[tag=center,scores={pound=17}] run execute as @e[tag=ai,limit=1,sort=nearest] at @s run summon armor_stand ^ ^ ^8 {Tags:[slam_wave],NoGravity:1,Invisible:1,Marker:1}
execute as @e[tag=slam_wave] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=ai,limit=1] Rotation[0] 1
execute as @e[tag=slam_wave] at @s run tp @s ^ ^ ^2
scoreboard players add @e[tag=slam_wave] wave_lt 1
kill @e[tag=slam_wave,scores={wave_lt=20..}]
execute at @e[tag=slam_wave] run particle block cobblestone ~ ~0.2 ~ 3 0 3 0.1 2 force
execute at @e[tag=slam_wave] run particle block stone ~ ~0.2 ~ 3 0 3 0.1 2 force
execute at @e[tag=slam_wave] run particle block dirt ~ ~0.2 ~ 3 0 3 0.1 2 force
execute at @e[tag=slam_wave] run effect give @a[distance=..5,scores={slam_cd=..0}] wither 4 2 true
execute at @e[tag=slam_wave] run effect give @a[distance=..5,scores={slam_cd=..0}] levitation 1 65 true
execute at @e[tag=slam_wave] run scoreboard players set @a[distance=..5,scores={slam_cd=..0}] slam_cd 10

scoreboard players add @a slam_cd 0
scoreboard players remove @a[scores={slam_cd=1..}] slam_cd 1
effect clear @a[scores={slam_cd=7}] levitation


############################################################# Jump #################################################################

scoreboard players add @e[tag=center] c_jump 0
scoreboard players add @e[tag=center,scores={c_jump=1..}] c_jump 1
scoreboard players set @e[tag=center,scores={c_jump=35..}] c_jump 0
scoreboard players operation @e[tag=arm] c_jump = @e[tag=center] c_jump


execute as @e[tag=center,scores={c_jump=2}] at @s run playsound jump master @a ~ ~ ~ 2.0 1
execute as @e[tag=center,scores={c_jump=7}] at @s run data merge entity @e[tag=ai,sort=nearest,limit=1] {Motion:[0.0,0.8,0.0]}

scoreboard players remove @e[tag=arm,scores={c_jump=1..15,arm_swing=-80..}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={c_jump=4..15,arm_swing=-80..}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={c_jump=6..15,arm_swing=-80..}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={c_jump=8..15,arm_swing=-80..}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={c_jump=10..15,arm_swing=-80..}] arm_swing 2
scoreboard players remove @e[tag=arm,scores={c_jump=12..15,arm_swing=-80..}] arm_swing 2

scoreboard players add @e[tag=arm,scores={c_jump=20..35,arm_swing=..0}] arm_swing 2
scoreboard players add @e[tag=arm,scores={c_jump=23..35,arm_swing=..0}] arm_swing 2
scoreboard players add @e[tag=arm,scores={c_jump=26..35,arm_swing=..0}] arm_swing 2
scoreboard players add @e[tag=arm,scores={c_jump=29..35,arm_swing=..0}] arm_swing 2
execute as @e[tag=center,scores={c_jump=32}] at @s run particle block dirt ~ ~0.2 ~ 3 0 3 0.1 80 force
execute as @e[tag=center,scores={c_jump=32}] at @s run effect give @a[distance=..7] instant_damage 1 0 true

execute as @e[tag=arm] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s arm_swing










############################################################# Laser #################################################################



scoreboard players add @e[tag=center] laser 0
scoreboard players add @e[tag=center,scores={laser=1..}] laser 1
scoreboard players set @e[tag=center,scores={laser=70..}] laser 0
scoreboard players operation @e[tag=head] laser = @e[tag=center] laser

execute as @e[tag=center,scores={laser=1..65}] at @s run data merge entity @e[tag=ai,limit=1] {NoAI:1}
execute as @e[tag=center,scores={laser=66..}] at @s run data merge entity @e[tag=ai,limit=1] {NoAI:0}
execute as @e[tag=center,scores={laser=1..}] at @s run tag @a remove laser_goal
execute as @e[tag=center,scores={laser=1..}] at @s run tag @p add laser_goal
execute as @e[tag=center,scores={laser=1..}] at @s run tp @e[tag=ai,limit=1,sort=nearest] ~ ~ ~ facing entity @a[tag=laser_goal,limit=1]
execute as @e[tag=center,scores={laser=1..}] at @s run execute as @e[tag=head,limit=1,sort=nearest] at @s run tp @s ~ ~ ~ facing entity @a[tag=laser_goal,limit=1]
execute as @e[tag=center,scores={laser=1..}] at @s run execute as @e[tag=head,limit=1,sort=nearest] at @s run execute store result entity @s Pose.Head[0] float 1 run data get entity @s Rotation[1] 1
execute as @e[tag=center,scores={laser=2..60}] at @s run execute as @e[tag=head,limit=1,sort=nearest] at @s run summon area_effect_cloud ^ ^3 ^ {Duration:0,Tags:[laser_ray],NoGravity:1}
execute as @e[tag=center,scores={laser=2..60}] at @s run execute as @e[tag=laser_ray] at @s run function cyclops:laser_tp
execute as @e[tag=center,scores={laser=2..60}] at @s run kill @e[tag=laser_ray]

data merge entity @e[tag=head,limit=1,scores={laser=1..62}] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:12}}]}
data merge entity @e[tag=head,limit=1,scores={laser=63}] {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:5}}]}

execute as @e[tag=center,scores={laser=2}] at @s run playsound laser master @a ~ ~ ~ 2.0 1












########################################################## Stone rain #################################################################

scoreboard players add @e[tag=center] stones 0
scoreboard players add @e[tag=center,scores={stones=1..}] stones 1
scoreboard players set @e[tag=center,scores={stones=180..}] stones 0
scoreboard players operation @e[tag=arm] stones = @e[tag=center] stones

execute as @e[tag=center,scores={stones=2}] at @s run scoreboard players set @e[tag=arm] arm_z 0
execute as @e[tag=center,scores={stones=2..20}] at @s run scoreboard players remove @e[tag=arm_left] arm_z 1
execute as @e[tag=center,scores={stones=2..20}] at @s run scoreboard players add @e[tag=arm_right] arm_z 1
execute as @e[tag=center,scores={stones=6..18}] at @s run scoreboard players remove @e[tag=arm_left] arm_z 2
execute as @e[tag=center,scores={stones=6..18}] at @s run scoreboard players add @e[tag=arm_right] arm_z 2
execute as @e[tag=center,scores={stones=9..15}] at @s run scoreboard players remove @e[tag=arm_left] arm_z 2
execute as @e[tag=center,scores={stones=9..15}] at @s run scoreboard players add @e[tag=arm_right] arm_z 2

execute as @e[tag=center,scores={stones=20..36}] at @s run scoreboard players add @e[tag=arm_left] arm_z 2
execute as @e[tag=center,scores={stones=20..36}] at @s run scoreboard players remove @e[tag=arm_right] arm_z 2
execute as @e[tag=center,scores={stones=23..34}] at @s run scoreboard players add @e[tag=arm_left] arm_z 2
execute as @e[tag=center,scores={stones=23..34}] at @s run scoreboard players remove @e[tag=arm_right] arm_z 2
execute as @e[tag=center,scores={stones=37}] at @s run scoreboard players set @e[tag=arm_left] arm_z 0
execute as @e[tag=center,scores={stones=37}] at @s run scoreboard players set @e[tag=arm_right] arm_z 0

execute as @e[tag=center,scores={stones=2}] at @s run playsound meteor_rise master @a ~ ~ ~ 2.0 1


execute as @e[tag=center,scores={stones=2}] at @s run summon armor_stand ~ ~-2 ~ {Tags:[stone_center],NoGravity:1,Invisible:1,Marker:1}
execute as @e[tag=center,scores={stones=2}] at @s run summon armor_stand ~ ~-2 ~ {Tags:["stone","stone1"],NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1,Marker:1}
execute as @e[tag=center,scores={stones=2}] at @s run summon armor_stand ~ ~-2 ~ {Tags:["stone","stone2"],NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1,Marker:1}
execute as @e[tag=center,scores={stones=2}] at @s run summon armor_stand ~ ~-2 ~ {Tags:["stone","stone3"],NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1,Marker:1}
execute as @e[tag=center,scores={stones=2}] at @s run summon armor_stand ~ ~-2 ~ {Tags:["stone","stone4"],NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1,Marker:1}
execute as @e[tag=center,scores={stones=2..40}] at @s run data merge entity @e[tag=ai,limit=1,sort=nearest] {Motion:[0.0,0.0,0.0]}
execute as @e[tag=center,scores={stones=21..150}] at @s run tp @e[tag=stone_center] ~ ~11 ~ 
execute as @e[tag=center,scores={stones=2..16}] at @s run execute as @e[tag=stone_center] at @s run tp @s ~ ~0.7 ~ 
execute as @e[tag=center,scores={stones=17..20}] at @s run execute as @e[tag=stone_center] at @s run tp @s ~ ~0.6 ~ ~2 ~
execute as @e[tag=center,scores={stones=2..70}] at @s run execute as @e[tag=stone_center] at @s run tp @e[tag=stone1] ^ ^ ^7
execute as @e[tag=center,scores={stones=2..80}] at @s run execute as @e[tag=stone_center] at @s run tp @e[tag=stone2] ^ ^ ^-7
execute as @e[tag=center,scores={stones=2..90}] at @s run execute as @e[tag=stone_center] at @s run tp @e[tag=stone3] ^7 ^ ^ 
execute as @e[tag=center,scores={stones=2..100}] at @s run execute as @e[tag=stone_center] at @s run tp @e[tag=stone4] ^-7 ^ ^ 
execute as @e[tag=center,scores={stones=21..150}] at @s run execute as @e[tag=stone_center] at @s run tp @s ~ ~ ~ ~3 ~ 
execute as @e[tag=center,scores={stones=21..150}] at @s run execute as @e[tag=stone] at @s run tp @s ~ ~ ~ ~3 ~ 

execute as @e[tag=center,scores={stones=70}] at @s run playsound meteor_launch master @a ~ ~ ~ 1.6 1
execute as @e[tag=center,scores={stones=70}] at @s run data merge entity @e[tag=stone1,limit=1] {Motion:[0.0,3.0,0.0],NoGravity:0}
execute as @e[tag=center,scores={stones=70}] at @s run tag @e[tag=stone1] remove stone
execute as @e[tag=center,scores={stones=90}] at @s run kill @e[tag=stone1]

execute as @e[tag=center,scores={stones=80}] at @s run playsound meteor_launch master @a ~ ~ ~ 1.6 1
execute as @e[tag=center,scores={stones=80}] at @s run data merge entity @e[tag=stone2,limit=1] {Motion:[0.0,3.0,0.0],NoGravity:0}
execute as @e[tag=center,scores={stones=80}] at @s run tag @e[tag=stone2] remove stone
execute as @e[tag=center,scores={stones=100}] at @s run kill @e[tag=stone2]

execute as @e[tag=center,scores={stones=90}] at @s run playsound meteor_launch master @a ~ ~ ~ 1.6 1
execute as @e[tag=center,scores={stones=90}] at @s run data merge entity @e[tag=stone3,limit=1] {Motion:[0.0,3.0,0.0],NoGravity:0}
execute as @e[tag=center,scores={stones=90}] at @s run tag @e[tag=stone3] remove stone
execute as @e[tag=center,scores={stones=110}] at @s run kill @e[tag=stone3]

execute as @e[tag=center,scores={stones=100}] at @s run playsound meteor_launch master @a ~ ~ ~ 1.6 1
execute as @e[tag=center,scores={stones=100}] at @s run data merge entity @e[tag=stone4,limit=1] {Motion:[0.0,3.0,0.0],NoGravity:0}
execute as @e[tag=center,scores={stones=100}] at @s run tag @e[tag=stone4] remove stone
execute as @e[tag=center,scores={stones=120}] at @s run kill @e[tag=stone4]

execute as @e[tag=center,scores={stones=110}] at @s run execute at @p run summon armor_stand ~ ~15 ~2 {Tags:[meteor],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1} 
execute as @e[tag=center,scores={stones=130}] at @s run execute at @p run summon armor_stand ~ ~15 ~-2 {Tags:[meteor],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1} 
execute as @e[tag=center,scores={stones=150}] at @s run execute at @p run summon armor_stand ~-2 ~15 ~ {Tags:[meteor],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1} 
execute as @e[tag=center,scores={stones=170}] at @s run execute at @p run summon armor_stand ~-2 ~15 ~ {Tags:[meteor],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",Count:1,tag:{Unbreakable:1,Damage:11}}],Invisible:1} 

execute as @e[tag=center,scores={stones=150}] at @s run kill @e[tag=stone_center]
execute as @e[tag=center,scores={stones=150}] at @s run kill @e[tag=stone]

execute as @e[tag=arm] at @s run execute store result entity @s Pose.Head[2] float 1 run scoreboard players get @s arm_z



execute as @e[tag=meteor] at @s run
execute as @e[tag=meteor,nbt={OnGround:1b}] at @s run effect give @a[distance=..6] instant_damage 1 0 true
execute as @e[tag=meteor,nbt={OnGround:1b}] at @s run playsound minecraft:entity.generic.explode master @a
execute as @e[tag=meteor,nbt={OnGround:1b}] at @s run particle minecraft:explosion ~ ~1 ~ 2 2 2 0.1 20 force
execute as @e[tag=meteor,nbt={OnGround:1b}] at @s run kill @s
execute as @e[tag=meteor] at @s run































































